
%denna fil genererar sjlva simplex-matrisen, givet m och n m2,n2.
lmargin=10;
bmargin=10;
tmargin=10;
rmargin=10;
xspace=5;
yspace=5;


% storlek p tal-rutor
rutax=50;
rutay=17;

% storlek p namnrutor
namnx=50;
namny=10;

% storlek p radiobuttons
butx=50;
buty=18;

%storlek p kommandoknappar
knappx=100;
knappy=20;

%Frg hos kolumn under editering
edcol=[1 0.93 0.93];
% frg hos ruta med fel
errcol=[1 0.1 0.1];
% standardfrg
normcol=[1 1 1];

%bakgrund
bgcol=[0.8 0.8 0.8];
fgcol=[0 0 0];
butcol=[0.701961 0.701961 0.701961];


% anger om tal visas som brk eller decimaltal
frac=1;
%anger om vi har en giltig bas eller inte.

if (exist('h0')~=0),
   fonsterpos=get(h0,'Position');
   close(h0)
end;


%Skapa storlek p frnstret, Kan behva editeras fr annat n sun.
xs=100;
ys=100;

% generera frnstret p samma stlle som tidigare.
if exist('fonsterpos')
   fonsterpos(3)=xs;
   fonsterpos(4)=ys;
% eller p nytt stlle om gammalt ej finns

else
   fonsterpos=[200 200 xs ys];
end

% skapa figuren.
h0 = figure('Color',bgcol, ...
     'Units','points', ...
     'Position',fonsterpos, ...
     'Tag','Fig1', ...
     'Name','Meny');

% skapa invBrutorna
invB_off=[lmargin+rutax,bmargin+rutay+yspace];
[invBrut,invB_end]=addmat(m,m,'invBruta',invB_off,rutax,rutay,'inactive',normcol,h0);

%samt lite text
pos=[lmargin,(invB_off(2)+invB_end(2))/2];
addtext('B^{-1}=',pos,bgcol,fgcol,h0);

%namn fr dessa
invBname_off=[invB_off(1),invB_end(2)+yspace];
name=cell(1,m);
   for i=1:n, name{1,i}='';
end;
[invBname,invBname_end]=addname(1,m,name,invBname_off,namnx,namny,bgcol,fgcol,h0);
% och lite text
addtext('Bas',invBname_off-[rutax,0],rutax,fgcol,h0);



%skapa Brutorna
B_off=[lmargin+rutax,invBname_end(2)+yspace];
[Brut,B_end]=addmat(m,m,'Bruta',B_off,rutax,rutay,'inactive',normcol,h0);

%samt lite text
pos=[lmargin,(B_off(2)+B_end(2))/2];
addtext('B=',pos,rutax,fgcol,h0);

%namn fr dessa
Bname_off=[B_off(1),B_end(2)+yspace];
[Bname,Bname_end]=addname(1,m,name,Bname_off,namnx,namny,bgcol,fgcol,h0);
% och lite text
addtext('Bas',Bname_off-[rutax,0],rutax,fgcol,h0);


%skapa redcostraden
rc_off=[B_end(1)+3*xspace B_off(2)];
[rcrut,rc_end]=addmat(1,n,'rcruta',rc_off,rutax,rutay,'inactive',normcol,h0);

%Skapa radiobuttons ovanfr redkostnadsraden 
inbut_off=[rc_off(1) rc_end(2)+yspace];
varnames=cell(1,n);
for i=1:n,
   varnames{1,i}=['x' num2str(i)];
end
[inbut,inbut_end]=addradio(1,n,varnames,inbut_off,butx,buty,h0);


%ange inkommande
menink=addbut([inbut_end(1)+xspace inbut_off(2) knappx knappy],'Give incoming','menink','angeink',butcol,h0);


%skapa rubrik ovan radiobutons
pos=[inbut_off(1), inbut_end(2)+yspace];
addtext('Reduced cost (c^T-c_B^TB^{-1}A):',pos,bgcol,fgcol,h0);



% lgg till rad fr rt
col_off=[invB_end(1)+rutax+xspace*3, invB_off(2)];
[colrut,col_end]=addmat(m,1,'colruta',col_off,rutax,rutay,'inactive',normcol,h0);

% samt text;
BApos=[invB_end(1)+xspace, (invB_end(2)+invB_off(2))/2];
addtext('B^{-1}A(:,i)=',BApos,bgcol,fgcol,h0);

% och namn
BAname_off=[col_off(1),col_end(2)+yspace];
[BAname,BAname_end]=addname(1,1,name,BAname_off,namnx,namny,bgcol,fgcol,h0);



% rad fr B^-1b
Bb_off=[col_end(1)+rutax, col_off(2)];
[Bbrut,Bb_end]=addmat(m,1,'Bbruta',Bb_off,rutax,rutay,'inactive',normcol,h0);

%samt text
pos=[col_end(1)+xspace, (Bb_off(2)+Bb_end(2))/2];
addtext('B^{-1}b=',pos,bgcol,fgcol,h0);


%mlfunktionsruta
z_off=[Bb_off(1),Bb_off(2)-yspace-rutay];
[zrut,z_end]=addmat(1,1,'zruta',z_off,rutax,rutay,'inactive',normcol,h0);

%samt text
pos=[z_off(1)-2.5*rutax, (z_off(2)+z_end(2))/2-6];
addtext('Optimal value z=c^T_BB^{-1}b=',pos,bgcol,fgcol,h0);

%knappar fr utgende
utbut_off=[Bb_end(1)+xspace,Bb_off(2)];
[utbut,utbut_end]=addradio(m,1,varnames',utbut_off,butx,buty,h0);

%knapp fr basbyte
menbyt=addbut([utbut_end(1)+xspace utbut_off(2)+knappy knappx knappy],'Change basis','menink','angebyt',butcol,h0);

%knapp fr ta bort rad
mentr=addbut([utbut_end(1)+xspace utbut_off(2) knappx knappy],'Remove row','mentr','tabortrad',butcol,h0);


mat_off(1)=lmargin+rutax;
mat_off(2)=max(inbut_end(2)+2*yspace+2*namny,Bname_end(2)+yspace);

%Skapa matrisrutorna
clear Arut;
[Arut,mat_end]=addmat(m,n,'ruta',mat_off,rutax,rutay,'inactive',normcol,h0);

% samt text
pos=[lmargin,(mat_off(2)+mat_end(2))/2];
addtext('A=',pos,bgcol,fgcol,h0);

% skapa kostnadsrutorna
clear crut;
cost_off=[mat_off(1),mat_end(2)+yspace];
[crut,cost_end]=addmat(1,n,'cruta',cost_off,rutax,rutay,'inactive',normcol,h0);

%lite text
pos=[cost_off(1)-rutax, (cost_off(2)+cost_end(2))/2];
addtext('c^T=',pos,bgcol,fgcol,h0);


% samt radiobuttons
cbut_off=[cost_off(1),cost_end(2)+yspace];
[cbut,cbut_end]=addradio(1,n,varnames,cbut_off,butx,buty,h0);

%ange bas
% ange-bas knappen
menab=addbut([cbut_end(1)+xspace cbut_off(2) knappx knappy],'Supply basis','menab','angebas',butcol,h0);

%ta bort kolumn
% ange-bas knappen
mentk=addbut([cbut_end(1)+xspace cbut_off(2)-knappy knappx knappy],'Remove column','mentk','tabortkol',butcol,h0);





% skapa hledsrutorna
b_off=[mat_end(1)+xspace+rutax,mat_off(2)];
[brut,b_end]=addmat(m,1,'bruta',b_off,rutax,rutay,'inactive',normcol,h0);

% samt text
pos=[mat_end(1)+xspace,(b_off(2)+b_end(2))/2];
addtext('b=',pos,bgcol,fgcol,h0);


k_off(1)=lmargin+rutax;
k_off(2)=cbut_end(2)+yspace;


% ny kolumn
mennk=uicontrol('Parent',h0, ...
        'Units','points', ...
        'BackgroundColor',[0.701961 0.701961 0.701961], ...
        'Callback','nykol', ...
        'Position',[k_off(1)+2*knappx k_off(2)+1*knappy knappx knappy], ...
        'String','New column', ...
        'Tag','mennk');

% ny rad
mennr=uicontrol('Parent',h0, ...
        'Units','points', ...
        'BackgroundColor',[0.701961 0.701961 0.701961], ...
        'Callback','nyrad', ...
        'Position',[k_off(1)+1*knappx k_off(2)+1*knappy knappx knappy], ...
        'String','New row', ...
        'Tag','mennr');

% editera
mened=uicontrol('Parent',h0, ...
        'Units','points', ...
        'BackgroundColor',[0.701961 0.701961 0.701961], ...
        'Callback','editera', ...
        'Position',[k_off(1)+0*knappx k_off(2)+1*knappy knappx knappy], ...
        'Style','togglebutton', ...
        'String','Edit', ...
        'Value',0, ...
        'Tag','menat');

% Avsluta
mendu=uicontrol('Parent',h0, ...
        'Units','points', ...
        'BackgroundColor',[0.701961 0.701961 0.701961], ...
        'Callback','avslut', ...
        'Position',[k_off(1)+3*knappx k_off(2)+1*knappy knappx knappy], ...
        'String','Quit', ...
        'Value',0, ...
        'Tag','menat');

% sparaknappen
mensp=uicontrol('Parent',h0, ...
        'Units','points', ...
        'BackgroundColor',[0.701961 0.701961 0.701961], ...
        'Callback','spara', ...
        'Position',[k_off(1)+0 k_off(2)+0 knappx knappy], ...
        'String','Save', ...
        'Tag','mensp');

% hmtaknappen
menhe=uicontrol('Parent',h0, ...
        'Units','points', ...
        'BackgroundColor',[0.701961 0.701961 0.701961], ...
        'Callback','hamta', ...
        'Position',[k_off(1)+knappx k_off(2)+0 knappx knappy], ...
        'String','Retrieve', ...
        'Tag','menhe');


% filnamnet
menft=uicontrol('Parent',h0, ...
        'Backgroundcolor',[0.8 0.8 0.8], ...
        'Foreground',[0 0 0], ...
        'Units','points', ...
        'Position',[k_off(1)+2*knappx k_off(2)-5 knappx knappy], ...
        'Style','text', ...
        'string','Filename:', ...
        'Tag','menft');

menfi=uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[1 0.95 0.95], ...
	'ListboxTop',0, ...
	'Position',[k_off(1)+3*knappx k_off(2)+0 knappx knappy], ...
	'Style','edit', ...
	'Tag','menfi');






% och fixa storleken.

%Skapa storlek p frnstret, Kan behva editeras fr annat n sun.
xs=max(get(menbyt,'position')*[1;0;1;0],get(menink,'position')*[1;0;1;0])+rmargin;
ys=(k_off(2)+3*rutay+tmargin);

pos=get(h0,'Position');
pos(3)=xs;
pos(4)=ys;
set(h0,'Position',pos);
